function f = gmm(mu,sigma)
% %Test Code
% mu = 2*(rand(2,10)-.25)
% f = gmm(mu,.1);
% 
% [X Y] = meshgrid(0:.05:1);
% Z = reshape(f([X(:) Y(:)]'), size(X));
% figure(1), clf, surf(X,Y,Z);
  
  [d n] = size(mu);
  
  function out = g(x)
    out = 0;
    for i=1:n
      out = out + gaussian(x,mu(:,i),sigma);
    end
  end

  f = @g;
end

% function y = gaussian(x,muG,sigma)
%   [dM nM] = size(muG);
%   [dX,nX] = size(x);    
%   if dM ~= dX, error('dimension mismatch!'); end
%   muG = repmat(muG,[1,nX]);
% %   S = sigma*eye(dX);    
% %   y = 1/((2*pi)^(dX/2)*det(S)^(1/2))*...
% %       exp(-.5*diag((x - muG)'*inv(S)*(x-muG)))';
% 
%   S = sigma*eye(dX);    
%   y = 1/((2*pi)^(dX/2)*det(S)^(1/2))*...
%       exp(-.5*diag((x - muG)'*inv(S)*(x-muG)))';       
% end

function y = gaussian(x,muG,sigma)
  [dX,nX] = size(x);    
  muG = repmat(muG,[1,nX]);
  y = (2*pi*sigma)^(-dX/2) * exp(-.5/sigma * sum((x - muG).^2,1));       
end


